# RealisticHeightDependentFog02.py

# This is simply bagginsbill's "DepthCueCamPosAutomation.py" from his sample UnderWaterRuntime, but with all stuff not required for camera position automation stripped out
# This post https://www.renderosity.com/forums/comments/4261682/permalink had a link to the relevant tutorial scene BBUnderWaterRuntime.zip on bagginsbill's GoogleSites ( https://sites.google.com/site/bagginsbill/free-stuff/tutorial-scenes ), but that no longer works. 
# However, a site snapshot is available via the Wayback Machine https://web.archive.org/web/20201020033511/https://sites.google.com/site/bagginsbill/free-stuff/tutorial-scenes and the download link still works (as at 29 Nov 2023)
import poser

scene = poser.Scene()

class cheapskatesTemporaryClass(object):
	lastCameraPosition = None
	lastUnit = None
	lastSurface = None
	lastHalfDistance = None
	lastScatter = None

	def Actor(self, name):
		scene = self.scene
		try:
			return scene.Actor(name)
		except:
			return scene.Actor(name + "_1")

	# Callback function
	def parameterAutomationCallback(self, scene, e):
		self.scene = scene
		cam = scene.CurrentCamera()
		pos = cam.WorldDisplacement()
		shaderTree = scene.AtmosphereShaderTree()
		posNode, halfDistanceNode = self.fromShaderTreeGet(shaderTree, 
			'PM:Camera Position', 'PM:Half Distance')
		k = 103.200005
		halfDistance = halfDistanceNode.Input(1).Value()
		if pos != self.lastCameraPosition:
			tempstr = 'Camera position updated to '
			self.lastCameraPosition = pos
			for i in xrange(3):
				posNode.Input(i).SetFloat(pos[i] * k)
				tempstr = tempstr + str(pos[i] * k) +', '
			shaderTree.UpdatePreview()
			print tempstr
				

	#
	def fromShaderTreeGet(self, shaderTree, *names):
		nodes = shaderTree.Nodes()
		lookup = {}
		for node in nodes:
			lookup[node.Name()] = node
		rv = [lookup.get(name) for name in names]
		if len(names) == 1:
			return rv[0]
		return rv

	def activate(self):
		poser.Scene().SetEventCallback(self.parameterAutomationCallback)
		print 'Parameter Automation Activated'

	def deactivate(self):
		poser.Scene().ClearEventCallback()
		print 'Parameter Automation Deactivated'
		
	# Added a main function to call UnderWaterAutomator().activate()
	def main(self):
		self.activate()


#if 'bb_memo' not in sys.modules:
	#import imp
	#sys.modules['bb_memo'] = imp.new_module('bb_memo')

			
poser.DialogSimple.MessageBox("Running 3DCheapskates RealisticHeightDependentFog02.py script\n\n(N.B. You should see a similar message when the script finishes. If you don't then the script has crashed!)")
cheapskatesTemporaryInstance = cheapskatesTemporaryClass()
cheapskatesTemporaryInstance.main()
poser.DialogSimple.MessageBox("3DCheapskates RealisticHeightDependentFog02.py script all done.")
